unit aidcore;

(************************************)
(*                                  *)
(* AINC Demo Designer Core Routines *)
(*                                  *)
(************************************)

interface

function aid_setFrame(frame:integer):integer;
function aid_reload:boolean;
function aid_startDebug:boolean;
function aid_getScript:pointer;
function aid_getScriptLength:integer;

implementation
uses windows;
type TDllStartSock=function:integer;cdecl;
type TDllSetFrame=function (frame:integer):integer;cdecl;
type TDllNeedReload=function :boolean;cdecl;
type TDllGetScriptAdress=function :pointer;cdecl;
type TDllGetScriptLength=function :integer;cdecl;

var
    dllStartSock : TDLLStartSock;
    dllSetFrame : TDllSetFrame;
    dllNeedReload : TDllNeedReload;
    DllGetScriptAdress : TDllGetScriptAdress ;
    DllGetScriptLength : TDllGetScriptLength;

    DLLHnd : integer;

    flag_debug : boolean;

function aid_setFrame(frame:integer):integer;
begin
  if flag_debug then result := dllSetFrame(frame) else result := frame;
end;

function aid_reload:boolean;
begin
  if flag_debug then result := dllNeedReload else result := false;
end;

function aid_getScript:pointer;
begin
  if flag_debug then result := dllGetScriptAdress else result := nil;
end;

function aid_getScriptLength:integer;
begin
  if flag_debug then result := dllGetScriptLength else result := -1;
end;

function aid_startDebug:boolean;
begin
//  externe dll linken und so
  dllHnd := loadLibrary('aid_live.dll');
  if dllHnd<>0 then
  begin
    dllStartSock := getProcAddress(dllHnd,'STARTSOCK');
    dllSetFrame := getProcAddress(dllHnd,'SETFRAME');
    dllNeedReload := getProcAddress(dllHnd,'RELOAD');
    DllGetScriptAdress := getProcAddress(dllHnd,'SCRIPTADDR');
    dllGetScriptLength := getProcAddress(dllHnd,'SCRIPTLEN');
    if
      (@dllStartSock<>nil) and
      (@dllSetFrame<>nil) and
      (@dllNeedReload<>nil) and
      (@dllGetScriptAdress<>nil) and
      (@dllGetScriptLength<>nil) then flag_debug:=(dllStartSock=1);
  end;
  result := flag_debug;
end;


begin
  flag_debug := false;
end.
