#include "liveed.h"

SThread *serverThread;


extern "C"

__declspec ( dllexport ) int STARTSOCK()
{
		//create server socket + thread
		{
			WSADATA wsa;
			if (WSAStartup(MAKEWORD(1, 1), &wsa))
			{
				return FALSE;
			}
		}

		
		liveSock = socket(AF_INET,SOCK_STREAM,0);
		struct sockaddr_in addr;
		addr.sin_addr.s_addr = INADDR_ANY; 	/* z.B. inet_addr("127.0.0.1"); */
		addr.sin_port = htons(12345); 		/* z.B. htons(80);              */
		addr.sin_family = AF_INET;
		if (bind(liveSock,(sockaddr*)&addr,sizeof(struct sockaddr_in))!=0) return 0;
		if (listen(liveSock,1)!=0) return 0;
		serverThread=new SThread(liveSock);
		script = malloc(256);
		return 1;
}

BOOL WINAPI DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	if (ul_reason_for_call == DLL_PROCESS_ATTACH)
	{
		DisableThreadLibraryCalls(hInst);
	}
	if (ul_reason_for_call == DLL_PROCESS_DETACH)
	{
		//stop server socket thread
	}
	return TRUE;
}

//int SThread::mySock;

SThread::SThread(int sock)
{
	mySock = sock;
	ThreadHandle = CreateThread(0,0,run,(void *) &mySock,0,&ThreadID);
}

SThread::~SThread()
{
	closesocket(mySock);
}

#pragma pack(1)
struct EventMsg
{
          unsigned char msg;
		  int data;
};
#pragma pack(4)

#define LE_MSG_RELOAD 0
#define LE_MSG_PLAY 1
#define LE_MSG_FREEZE 2
#define LE_MSG_NEXTFRAME 3
#define LE_MSG_PREVFRAME 4
#define LE_MSG_PAUSE 5
#define LE_MSG_SEEK 6
#define LE_MSG_QUERY 7

DWORD WINAPI SThread::run( LPVOID arg)
{
	struct sockaddr_in cli;
	int cli_size;
	int ssock = *((int*)arg);
	cli_size = sizeof(cli);
	int c;
	EventMsg evmsg;
	if (sizeof(EventMsg)!=5) MessageBox(0,&"EventSize wrong",&"Error",0);
	while (1)
	{
		c = accept(ssock, (sockaddr*)&cli, &cli_size); 
		if (c==-1) break;  //cannot accept connections, exit main loop
		int keepalive=1;
		while (keepalive==1)
		{
			int bytesr = 0;
			while ((bytesr<sizeof(EventMsg))&&(keepalive==1))
			{ 
				int bobby = recv(c,(char*)(&evmsg)+bytesr,sizeof(EventMsg)-bytesr,0);
				if (bobby<=0) 
				{
//			MessageBox(0,&"Receive Error",&"Error",0);

					keepalive=0;
					break;
				}
				else bytesr += bobby;
			}
			if (keepalive!=1) break;
//			evmsg.data = ntohl(evmsg.data);
			switch (evmsg.msg)
			{
				case LE_MSG_RELOAD:
			
						bytesr=0;
						script=realloc(script,evmsg.data);
						while (bytesr<evmsg.data){ 
							int bobby = recv(c,(char*)(script)+bytesr,evmsg.data-bytesr,0);
							if (bobby<0) {keepalive=0;break;} else	bytesr += bobby;
						}
		
						reload=true;
						break;
				case LE_MSG_PLAY : 
						freeze=false;
						play=true;
						break;
				case LE_MSG_FREEZE :
						freeze=true;
						play=false;
						break;
				case LE_MSG_NEXTFRAME :
						play=false;
						thisFrame++;
						evmsg.msg=LE_MSG_PLAY;
						evmsg.data = thisFrame;
						send(c,(char*)&evmsg,sizeof(EventMsg),0);
						break;
				case LE_MSG_PREVFRAME :
						play=false;
						thisFrame--;
						evmsg.msg=LE_MSG_PLAY;
						evmsg.data = thisFrame;
						send(c,(char*)&evmsg,sizeof(EventMsg),0);
						break;
				case LE_MSG_PAUSE :
						play=false;
						evmsg.msg=LE_MSG_PLAY;
						evmsg.data = thisFrame;
						send(c,(char*)&evmsg,sizeof(EventMsg),0);
						break;
				case LE_MSG_SEEK :
						play=false;
						thisFrame=evmsg.data;
						evmsg.msg=LE_MSG_PLAY;
						evmsg.data = thisFrame;
						send(c,(char*)&evmsg,sizeof(EventMsg),0);
						break;
				case LE_MSG_QUERY :
						if (play) evmsg.msg=LE_MSG_PLAY;
						evmsg.data = thisFrame;
						send(c,(char*)&evmsg,sizeof(EventMsg),0);
						break;
			}
		}
		closesocket(c);
	}
	return 0;
}